<div class="timeline-content timeline-post-<?php echo esc_attr(get_the_ID()); ?>" id="timeline-horizontal-3">
	<div id="timeline-hori-3"> 
		<div id="line_timeline">
		</div>
	</div>
	<div id="mainCont">
	</div>
</div>

<?php 
$timelines = carbon_get_post_meta( get_the_ID(), 'timeline_items' );
$date_array = array();
$title_array = array();
$content_array = array();
$img_array = array();
$no = 0;
foreach ($timelines as $timeline) {
	$date_array[] = $timeline['timeline_date'];
	$title_array[] = $timeline['timeline_item_title'];
	$content_array[] = wp_specialchars_decode($timeline['timeline_item_content']);
	$img_array[] = wp_get_attachment_image( intval($timeline['timeline_item_img']), 'full' );
} ?>

<script type="text/javascript">
jQuery(document).ready(function($){
	var dates = <?php echo json_encode($date_array); ?>;
	//For the purpose of stringifying MM/DD/YYYY date format
	var monthSpan = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
	//For the purpose of stringifying MM/DD/YYYY date format
	var titles = <?php echo json_encode($title_array); ?>;
	var contents = <?php echo json_encode($content_array); ?>;
	var images = <?php echo json_encode($img_array); ?>;

	//Format MM/DD/YYYY into string
	function dateSpan(date) {
		var month = date.split('/')[0];
		month = monthSpan[month - 1];
		var day = date.split('/')[1];
		if (day.charAt(0) == '0') {
			day = day.charAt(1);
		}
		var year = date.split('/')[2];

		//Spit it out!
		return month + " " + day + ", " + year;
	}

	//Main function. Draw your circles.
	function makeCircles() {
		//Forget the timeline if there's only one date. Who needs it!?
		if (dates.length < 2) {
			$("#line_timeline").hide();
			$("#span").show().text(dateSpan(dates[0]));
			//This is what you really want.
		} else if (dates.length >= 2) {
			//Set day, month and year variables for the math
			var first = dates[0];
			var last = dates[dates.length - 1];

			var firstMonth = parseInt(first.split('/')[0]);
			var firstDay = parseInt(first.split('/')[1]);
			var firstYear = parseInt(first.split('/')[2]);

			var lastMonth = parseInt(last.split('/')[0]);
			var lastDay = parseInt(last.split('/')[1]);
			var lastYear = parseInt(last.split('/')[2]);

			//Integer representation of the last day. The first day is represnted as 0
			var lastInt = ((lastMonth - firstMonth) * 30) + (lastDay - firstDay);

			//Draw first date circle
			$("#line_timeline").append('<div class="circle" id="circle0" style="left: ' + 0 + '%;"><div class="popupSpan">' + dateSpan(dates[0]) + '</div></div>');

			$("#mainCont").append('<div id="span0" class="time-wrap center">' + '<span class="inner-img">' + images[0] + '</span>' + '<section class="content-hor3-wrapper">' + '<h1 class="timeline-title">' +  titles[0] + '</h1>' + '<h2 class="timeline-info">' + dateSpan(dates[0]) + '</h2>' + '<p class="timeline-text">' +  contents[0] + '</p>' + '</section>' + '</div>');

			//Loop through middle dates
			for (i = 1; i < dates.length - 1; i++) {
				var thisMonth = parseInt(dates[i].split('/')[0]);
				var thisDay = parseInt(dates[i].split('/')[1]);
				var thisYear = parseInt(dates[i].split('/')[2]);

				//Integer representation of the date
				var thisInt = ((thisMonth - firstMonth) * 30) + (thisDay - firstDay);

				//Integer relative to the first and last dates
				var relativeInt = thisInt / lastInt;

				//Draw the date circle
				$("#line_timeline").append('<div class="circle" id="circle' + i + '" style="left: ' + relativeInt * 100 + '%;"><div class="popupSpan">' + dateSpan(dates[i]) + '</div></div>');

				$("#mainCont").append('<div id="span' + i + '" class="time-wrap right">' + '<span class="inner-img">' + images[i] + '</span>' + '<section class="content-hor3-wrapper">' + '<h1 class="timeline-title">' +  titles[i] + '</h1>' + '<h2 class="timeline-info">' + dateSpan(dates[i]) + '</h2>' + '<p class="timeline-text">' +  contents[i] + '</p>' + '</section>' + '</div>');
			}

			//Draw the last date circle
			$("#line_timeline").append('<div class="circle" id="circle' + i + '" style="left: ' + 99 + '%;"><div class="popupSpan">' + dateSpan(dates[dates.length - 1]) + '</div></div>');

		   $("#mainCont").append('<div id="span' + [dates.length - 1] + '" class="time-wrap right">' + '<span class="inner-img">' + images[dates.length - 1] + '</span>' + '<section class="content-hor3-wrapper">' + '<h1 class="timeline-title">' +  titles[dates.length - 1] + '</h1>' + '<h2 class="timeline-info">' + dateSpan(dates[dates.length - 1]) + '</h2>' + '<p class="timeline-text">' +  contents[dates.length - 1] + '</p>' + '</section>' + '</div>');
		}

		$(".circle:first").addClass("active");
	}

	makeCircles();

	$(".circle").mouseenter(function() {
		$(this).addClass("hover");
	});

	$(".circle").mouseleave(function() {
		$(this).removeClass("hover");
	});

	$(".circle").click(function() {
		var spanNum = $(this).attr("id");
		selectDate(spanNum);
	});

	function selectDate(selector) {
		$selector = "#" + selector;
		$spanSelector = $selector.replace("circle", "span");
		var current = $selector.replace("circle", "");

		$(".active").removeClass("active");
		$($selector).addClass("active");

		if ($($spanSelector).hasClass("right")) {
			$(".center").removeClass("center").addClass("left")
			$($spanSelector).addClass("center");
			$($spanSelector).removeClass("right")
		} else if ($($spanSelector).hasClass("left")) {
			$(".center").removeClass("center").addClass("right");
			$($spanSelector).addClass("center");
			$($spanSelector).removeClass("left");
		};
	};
});
</script>