<?php
$timelines = carbon_get_post_meta(get_the_ID(), 'timeline_items');
?>

<div class="timeline-content vertical-4 timeline-post-<?php echo esc_attr(get_the_ID()); ?>" id="vertical-background">
	<div class="timeline timeline-background">
		<?php
		foreach ($timelines as $timeline) { ?>
			<div class="timeline-item" data-text="<?php echo esc_attr($timeline['timeline_item_title']); ?>">
				<div class="timeline__content"><?php echo wp_get_attachment_image($timeline['timeline_item_img'], 'full', '', array( 'class' => 'timeline__img' )); ?>
                    <h3 class="timeline-title mobile"><?php echo esc_html($timeline['timeline_item_title']); ?></h3>
					<h2 class="timeline__content-title timeline-info"><?php echo esc_html($timeline['timeline_date']); ?></h2>
					<p class="timeline__content-desc timeline-text"><?php echo wp_specialchars_decode($timeline['timeline_item_content']); ?></p>
				</div>
			</div>
		<?php } ?>
	</div>
</div>

<script>
(function($) {
    $.fn.timeline = function() {
        var selectors = {
            id: $(this),
            item: $(this).find(".timeline-item"),
            activeClass: "timeline-item--active",
            img: ".timeline__img"
        };
        selectors.item.eq(0).addClass(selectors.activeClass);
        selectors.id.css(
            "background-image",
            "url(" + selectors.item.first().find(selectors.img).attr("src") + ")"
        );
        var itemLength = selectors.item.length;
        $(window).scroll(function() {
            var max, min;
            var pos = $(this).scrollTop();
            selectors.item.each(function(i) {
                min = $(this).offset().top;
                max = $(this).height() + $(this).offset().top;
                var that = $(this);
                if (i == itemLength - 2 && pos > min + $(this).height() / 2) {
                    selectors.item.removeClass(selectors.activeClass);
                    selectors.id.css(
                        "background-image",
                        "url(" + selectors.item.last().find(selectors.img).attr("src") + ")"
                    );
                    selectors.item.last().addClass(selectors.activeClass);
                } else if (pos <= max - 40 && pos >= min) {
                    selectors.id.css(
                        "background-image",
                        "url(" + $(this).find(selectors.img).attr("src") + ")"
                    );
                    selectors.item.removeClass(selectors.activeClass);
                    $(this).addClass(selectors.activeClass);
                }
            });
        });
    };
})(jQuery);

jQuery("#vertical-background").timeline();

</script>