<?php
/*-----------------------------------------------------------------------------------*/
/* TImeline Awesome Post Type
/*-----------------------------------------------------------------------------------*/
add_action('init', 'timeline_awesome_register');

function timeline_awesome_register() {
    global $timeline_awesome_lbapi;
    global $timeline_awesome_lb_verify_res;

	$labels = array(
		'name'                => esc_html_x( 'Timelines', 'Post Type General Name', 'timeline-awesome' ),
		'singular_name'       => esc_html_x( 'Timelines', 'Post Type Singular Name', 'timeline-awesome' ),
		'menu_name'           => esc_html__( 'Timelines', 'timeline-awesome' ),
		'parent_item_colon'   => esc_html__( 'Parent Timelines:', 'timeline-awesome' ),
		'all_items'           => esc_html__( 'All Timelines', 'timeline-awesome' ),
		'view_item'           => esc_html__( 'View Timelines', 'timeline-awesome' ),
		'add_new_item'        => esc_html__( 'Add New Timelines', 'timeline-awesome' ),
		'add_new'             => esc_html__( 'Add New', 'timeline-awesome' ),
		'edit_item'           => esc_html__( 'Edit Timelines', 'timeline-awesome' ),
		'update_item'         => esc_html__( 'Update Timelines', 'timeline-awesome' ),
		'search_items'        => esc_html__( 'Search Timelines', 'timeline-awesome' ),
		'not_found'           => esc_html__( 'Not found', 'timeline-awesome' ),
		'not_found_in_trash'  => esc_html__( 'Not found in Trash', 'timeline-awesome' ),
	);
	$args = array(
		'labels'             => $labels,
		'public'             => true,
		'publicly_queryable' => true,
		'show_ui'            => true,
		'query_var'          => 'timelines',
		'capability_type'    => 'post',
		'hierarchical'       => false,
		'rewrite'            => array( 'slug' => 'timelines' ),
		'supports'           => array('title'),
		'menu_position'       => 7,
		'has_archive'           => false,
		'exclude_from_search'   => true,
        'menu_icon'           => 'dashicons-editor-ul',
	);
    
    register_post_type( 'timeline-awesome', $args );

}

use Carbon_Fields\Container;
use Carbon_Fields\Field;
use Carbon_Fields\Block;

add_action( 'carbon_fields_register_fields', 'timeline_awesome_field_in_post' );
function timeline_awesome_field_in_post() {

global $timeline_awesome_lbapi;
global $timeline_awesome_lb_verify_res;

    if(($timeline_awesome_lb_verify_res['status'])) {
    require dirname( __FILE__ ) .'/timeline-awesome-ctrl.php';

    Container::make( 'post_meta', 'timeline_repeater_cont', esc_html('Timeline Awesome') )
    	->where( 'post_type', '=', 'timeline-awesome' )
    	->set_priority( 'high' )
        ->add_tab(  esc_html__( 'Layout', 'timeline-awesome' ), array(

            Field::make( 'select', 'timeline_style_choice', esc_html__( 'Select Style', 'timeline-awesome' ) )
            ->add_options( array(
                'vertical-1' => esc_html__('Vertical Hiji', 'timeline-awesome'),
                'vertical-2' => esc_html__('Vertical Dua', 'timeline-awesome'),
                'vertical-3' => esc_html__('Vertical Tilu', 'timeline-awesome'),
                'vertical-4' => esc_html__('Vertical Opat', 'timeline-awesome'),
                'vertical-5' => esc_html__('Vertical Lima', 'timeline-awesome'),
                'vertical-6' => esc_html__('Vertical Genep', 'timeline-awesome'),
                'vertical-7' => esc_html__('Vertical Tujuh', 'timeline-awesome'),
                'vertical-8' => esc_html__('Vertical Dalapan', 'timeline-awesome'),
                'vertical-9' => esc_html__('Vertical Salapan', 'timeline-awesome'),
                'vertical-10' => esc_html__('Vertical Sapuluh', 'timeline-awesome'),
                'horizontal-1' => esc_html__('Horizontal Hiji', 'timeline-awesome'),
                'horizontal-2' => esc_html__('Horizontal Dua', 'timeline-awesome'),
                'horizontal-4' => esc_html__('Horizontal Opat', 'timeline-awesome'),
                'horizontal-6' => esc_html__('Horizontal Genep', 'timeline-awesome'),
                'horizontal-9' => esc_html__('Horizontal Salapan', 'timeline-awesome'),
                'horizontal-10' => esc_html__('Horizontal Sapuluh', 'timeline-awesome')
            ) ),

            Field::make( 'select', 'timeline_screen_height', esc_html__( 'Timeline Layout Height', 'timeline-awesome' ) )
            ->set_conditional_logic( array(
                'relation' => 'OR',
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-5',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'horizontal-4',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'horizontal-6',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'horizontal-9',
                    'compare' => '=',
                ),
            ) )
            ->add_options( array(
                'default' => esc_html__('Default', 'timeline-awesome'),
                'fullscreen' => esc_html__('Full Screen', 'timeline-awesome')
            ) ),

            Field::make( 'number', 'header_height_custom', esc_html__( 'Header Height', 'timeline-awesome' ) )
            ->set_conditional_logic( array(
                array(
                    'field' => 'timeline_screen_height',
                    'value' => 'fullscreen',
                    'compare' => '=',
                )
            ) ),
        ))
    	->add_tab(  __( 'Content' ), array(

    		Field::make( 'complex', 'timeline_items', esc_html__( 'Timeline Items', 'timeline-awesome' ) )
    		->set_layout( 'tabbed-horizontal' )
    		->add_fields( array(

    				Field::make( 'text', 'timeline_item_title', esc_html__( 'Title', 'timeline-awesome' ) )
    				->set_attribute( 'placeholder', esc_html__('Timeline Title', 'timeline-awesome' ) )
    				->set_width( 40 ),

    				Field::make( 'text', 'timeline_date', esc_html__( 'Timeline Date', 'timeline-awesome' ) )
    				->set_attribute( 'placeholder', '2020' )
    				->set_width( 25 ),

    				Field::make( 'textarea', 'timeline_item_content', esc_html__( 'Timeline Content', 'timeline-awesome' ) )
    				->set_attribute( 'placeholder', esc_html__('Put your text here...', 'timeline-awesome' ) )
    				->set_width( 80 ),

    				Field::make( 'image', 'timeline_item_img', esc_html__( 'Timeline Image', 'timeline-awesome' ) )
    				->set_width( 20 ) ,

    				Field::make( 'separator', 'timeline_custom_option', esc_html__('Optional', 'timeline-awesome' ) ),

    				Field::make( 'icon', 'social_site_icon', esc_html__( 'Icon', 'timeline-awesome' ) )
    				->set_conditional_logic( array(
    					array(
    						'field' => 'parent.timeline_style_choice',
    						'value' => 'vertical-7',
    						'compare' => '=',
    					)
    				) )
    				->set_width( 40 ),

    				Field::make( 'text', 'timeline_item_subtitle', esc_html__( 'Subtitle', 'timeline-awesome' ) )
    				->set_conditional_logic( array(
    					array(
    						'field' => 'parent.timeline_style_choice',
    						'value' => 'vertical-2',
    						'compare' => '=',
    					)
    				) )
    				->set_width( 35 ),

                    Field::make( 'text', 'timeline_item_full_date', esc_html__( 'Full Date', 'timeline-awesome' ) )
                    ->set_conditional_logic( array(
                        array(
                            'field' => 'parent.timeline_style_choice',
                            'value' => 'horizontal-4',
                            'compare' => '=',
                        )
                    ) )
                    ->set_width( 35 ),
    				Field::make( 'color', 'timeline_horizontal_10_color', esc_html__( 'Timeline Color', 'timeline-awesome' ) )
    				->set_conditional_logic( array(
    					array(
    						'field' => 'parent.timeline_style_choice',
    						'value' => 'horizontal-10',
    						'compare' => '=',
    					)
    				) )
    				->set_palette( array( '#FF0000', '#00FF00', '#0000FF' ) ),
    		) )
    		->set_default_value( array(
    			array(
    			),
    		) ),
    	))
    	->add_tab(  __( 'Customize' ), array(
    		Field::make( 'color', 'timeline_title_color', esc_html__( 'Timeline Title Color', 'timeline-awesome' ) )
    		->set_width( 14 ),

    		Field::make( 'color', 'timeline_date_color', esc_html__( 'Timeline Date Color', 'timeline-awesome' ) )
    		->set_width( 14 ),

            Field::make( 'color', 'timeline_content_color', esc_html__( 'Timeline Content Color', 'timeline-awesome' ) )
            ->set_width( 14 ),

            Field::make( 'color', 'timeline_border_color', esc_html__( 'Timeline Border Color', 'timeline-awesome' ) )
            ->set_conditional_logic( array(
                'relation' => 'OR',
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-1',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-2',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-3',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-4',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-5',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-7',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'horizontal-2',
                    'compare' => '=',
                )
            ) )
            ->set_width( 14 ),

            Field::make( 'color', 'timeline_dot_color', esc_html__( 'Timeline Dot Color', 'timeline-awesome' ) )
            ->set_conditional_logic( array(
                'relation' => 'OR',
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-1',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-2',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-3',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-5',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'horizontal-2',
                    'compare' => '=',
                )
            ) )
            ->set_width( 14 ),

            Field::make( 'color', 'timeline_pag_color', esc_html__( 'Timeline Pagination Color', 'timeline-awesome' ) )
            ->set_conditional_logic( array(
                'relation' => 'OR',
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-5',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-6',
                    'compare' => '=',
                )
            ) )
            ->set_width( 14 ),

            Field::make( 'color', 'timeline_pag_active_color', esc_html__( 'Timeline Pagination Active Color', 'timeline-awesome' ) )
            ->set_conditional_logic( array(
                'relation' => 'OR',
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-5',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-6',
                    'compare' => '=',
                )
            ) )
            ->set_width( 14 ),

            Field::make( 'color', 'timeline_icon_color', esc_html__( 'Timeline Icon Color', 'timeline-awesome' ) )
            ->set_conditional_logic( array(
                'relation' => 'OR',
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-7',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'horizontal-2',
                    'compare' => '=',
                )
            ) )
            ->set_width( 14 ),

            Field::make( 'color', 'timeline_bag_icon_color', esc_html__( 'Timeline Icon Background Color', 'timeline-awesome' ) )
            ->set_conditional_logic( array(
                'relation' => 'OR',
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-7',
                    'compare' => '=',
                )
            ) )
            ->set_width( 14 ),

            Field::make( 'color', 'timeline_border_icon_color', esc_html__( 'Timeline Icon Border Color', 'timeline-awesome' ) )
            ->set_conditional_logic( array(
                'relation' => 'OR',
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-7',
                    'compare' => '=',
                ),
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'horizontal-2',
                    'compare' => '=',
                )
            ) )
            ->set_width( 14 ),

            Field::make( 'text', 'timeline_item_height_container', esc_html__( 'Height', 'timeline-awesome' ) )
            ->set_attribute( 'placeholder', esc_html__('1000', 'timeline-awesome' ) )
            ->set_conditional_logic( array(
                array(
                    'field' => 'timeline_style_choice',
                    'value' => 'vertical-5',
                    'compare' => '=',
                )
            ) )
            ->set_width( 35 ),
    	));

    	// For Gutenberg Blocks
    	Block::make( esc_html( 'Timeline Awesome' ) )
    	->add_fields( array(
    		Field::make( 'association', 'timeline_gutenberg_block', esc_html( 'Timeline Awesome Post') )
    		->set_min( 1 )
    		->set_max( 1 )
    		->set_types( array(
    			array(
    				'type'      => 'post',
    				'post_type' => 'timeline-awesome',
    			)
    		) )
    	) )
    	->set_render_callback( function ( $fields, $attributes, $inner_blocks ) {
    		require dirname( __FILE__ ) .'/gutenberg-blocks/timeline-block.php';
    	} );

    }
    else {
        Container::make( 'post_meta', 'activate_notice', esc_html__( 'Activate Key', 'timeline-awesome' ) )
        ->where( 'post_type', '=', 'timeline-awesome' )
        ->set_priority( 'high' )
        ->add_fields( array(

        Field::make( 'html', 'activate_notice_content', esc_html__( 'Info', 'timeline-awesome' ) )
            ->set_html( sprintf( 'Please activate your Timeline Awesome Pro key with your purchase code.' ) ),
        ));
    }
}